#include "ni_defs.h"
#include "ni_macro_defs_quadra.h"

#define STR_HELPER(x) #x
#define STR(x) STR_HELPER(x)

static constexpr bool is_string_equal(const char *l, const char *r)
{
    return (*l == *r) && (!*l || is_string_equal(l + 1, r + 1));  
}

#define CHECK_STRING_EQUAL(A, B) \
static_assert(is_string_equal((A), (B)), #A"=""'" A "'" "  and  " #B"=""'" B "'" "  are not equal")

#define CHECK_NUMBER_EQUAL(A, B) \
static_assert((A) == (B), #A"=" STR(A)  " and " #B"=" STR(B) "  are not equal")

CHECK_STRING_EQUAL(NI_XCODER_REVISION, NI_QUADRA_XCODER_REVISION);
CHECK_NUMBER_EQUAL(LIBXCODER_API_VERSION_MAJOR, LIBXCODER_QUADRA_API_VERSION_MAJOR);
CHECK_NUMBER_EQUAL(LIBXCODER_API_VERSION_MINOR, LIBXCODER_QUADRA_API_VERSION_MINOR);
